#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

void* xmalloc(size_t size)
{
	void* p = malloc(size);

	if (!p) {
		printf("Memory allocation error\n");
		exit(1);
	}

	return p;
}

void* xcalloc(size_t nmemb, size_t size)
{
	void* p = calloc(nmemb, size);

	if (!p) {
		printf("Memory allocation error\n");
		exit(1);
	}

	return p;
}

void* xrealloc(void *ptr, size_t size)
{
	void* p = realloc(ptr, size);

	if (!p) {
		printf("Memory allocation error\n");
		exit(1);
	}

	return p;
}

char* xstrdup(const char* s)
{
	void* p = strdup(s);

	if (!p) {
		printf("Memory allocation error\n");
		exit(1);
	}

	return p;
}
